import com.fazecast.jSerialComm.SerialPort;

public class SerialWriter {
    public static void main(String[] args) {
        // Get the available serial ports
        SerialPort[] serialPorts = SerialPort.getCommPorts();

        if (serialPorts.length > 0) {
            // Select the first available serial port
            SerialPort serialPort = serialPorts[0];

            // Open the serial port
            if (serialPort.openPort()) {
                System.out.println("Serial port opened successfully.");

                // Configure the serial port
                serialPort.setBaudRate(9600);
                serialPort.setNumDataBits(8);
                serialPort.setNumStopBits(SerialPort.ONE_STOP_BIT);
                serialPort.setParity(SerialPort.NO_PARITY);

                // Write data to the serial port
                String dataToSend = "Hello, Arduino!";
                byte[] bytes = dataToSend.getBytes();
                serialPort.writeBytes(bytes, bytes.length);

                System.out.println("Data sent to the serial port.");

                // Close the serial port
                serialPort.closePort();
                System.out.println("Serial port closed.");
            } else {
                System.out.println("Failed to open the serial port.");
            }
        } else {
            System.out.println("No serial ports found.");
        }
    }
}
